package netting;
import java.io.*;
import java.net.*;

public class BiServer extends Thread {

    protected ServerSocket ss;

    public BiServer(int port) {
      try { ss = new ServerSocket(port); }
      catch (IOException e) { System.err.println(e ); System.exit(1);}
      System.out.println("Server: listening on port " + port);
      this.start();
    }

    public void run() {
      try {
        while(true) {
          Socket cs = ss.accept();   // wait ;
          BiClerk c = new BiClerk(cs);
        }
      } catch (IOException e) { System.out.println(" "+e); }
    }

    // Start the server up, listening on an optionally specified port
    public static void main(String[] args) {
      new Server(5555);
  }
}

class BiClerk  {
  static int count;
  int id;
  protected Socket cs;
  protected BufferedReader in;
  protected PrintWriter out;
  String outline;

  ThreadIn  thIn;
  ThreadOut thOut;

  // Initialize the streams and start the thread
  public BiClerk(Socket cs) {
    this.cs=cs; id=++count;
    try {
      in = new BufferedReader(new InputStreamReader(cs.getInputStream()));
      out = new PrintWriter(cs.getOutputStream(),true /* autoFlush */ );
    }
    catch (IOException e) {
      try { cs.close(); } catch (IOException e2) { ; }
      System.err.println("Exception while getting socket streams: " + e);
      return;
    }
    System.out.println("clerk id="+id+"    on port:"+cs.getPort() );
  }

}

class ThreadIn extends Thread {
  BufferedReader in;
  String outLine;
  public ThreadIn(BufferedReader in, String oL) { this.in=in; this.outLine=oL;}

  public void run() {
    String line;
    StringBuffer revline;
    int len;
    try {
      for(;;) {
        line = in.readLine();   // read in a line
        if (line==null) break;
        len = line.length();
        outLine = new StringBuffer(line).reverse().toString();
      //  out.println(revline); // write reversed line
        System.out.println("clerk id="+" : "+line+"->"+outLine);
      }
      in.close();
    }
    catch (IOException e) { ; }
    finally {  }
    System.out.println("clerk id=   finished");
  }

}

class ThreadOut extends Thread {
}
