package netting;
import java.net.URL;
import java.io.*;
import java.util.Stack;

public class DeliverySurvey {
    static String 
      u0="http://www.ceskaposta.cz/cz/nastroje/sledovani-zasilky.php?barcode=",
      u1="&locale=EN&go=ok";  
    public static void main(final String[] args) throws Exception {
        System.out.println("\nDELIVERY SURVEY\n----------------------");
        
        FileReader fr=new FileReader("Kody.txt");
        BufferedReader br=new BufferedReader(fr);
        
        Stack stack=new Stack();
        
        String id;
        
        while ( (id=br.readLine()) != null ) { 
             if ( !(id.startsWith("#") && id.contains("BX")) ) continue; 
             int k=id.indexOf("BX");
             String code=id.substring(k).trim();
            
             URL url=new URL(u0+code+u1);
             System.out.print(id.substring(0, k)+"CODE="+code+"   ");
             
             InputStreamReader  isr=new InputStreamReader(url.openStream());  
             PassBufferedReader pbr=new PassBufferedReader(isr);   
             
             String line=null;
             while ( (line=pbr.readLine()) != null ) {
                 stack.push(line);
             }
             
             System.out.println("messages="+stack.size());
             System.out.println(">>> "+stack.pop());
             while(!stack.isEmpty()) { 
                 System.out.println("    "+stack.pop());
             }             
             pbr.close(); 
        }
        System.out.println("\nLISTING COMPLETED");
    }
}

class  PassBufferedReader extends BufferedReader {
        String start=">Information", stop="</table>";
        private int state=0;
        private boolean mk=false;        
        
    public PassBufferedReader(Reader r) {super(r); }

    @Override
    public  String readLine() throws IOException {
        String line;

        while( (line=super.readLine())!=null  ) {
            try {
                line=filter(line, ">Info", "</table>");
                if (line==null) continue;
                else return line;
            } catch (EOFException e) {  }                
        }
        return null;
    }   
        
        
    public String filter(String in, String start, String stop) throws EOFException {        
        String fl=in.trim();
        
        switch (state) {
            case 0:  if ( fl.contains(start)) state=1;  return null;
            case 1:  if (!fl.contains(stop) ) break;
                     else throw new EOFException("No need to continue");                   
        }
        if(mk) { mk=false;  return fl; }
        if( fl.startsWith("<td>") ) mk=true; 
        return null;
    }
        
}